package ai.pai.lensman.login;

import android.os.AsyncTask;

import com.android.common.executors.ThreadExecutor;

import java.util.HashMap;

import ai.pai.lensman.base.BaseInteractor;
import ai.pai.lensman.utils.HttpPostTask;
import ai.pai.lensman.utils.UrlContainer;

/**
 * Created by chengzhenyu on 2016/8/12.
 */
public class LoginInteractor implements BaseInteractor{

    private HttpPostTask loginTask;
    private String userName;
    private String password;
    private InteractorListener<String> listener;

    public LoginInteractor(String userName,String password,InteractorListener<String> listener){
        this.userName = userName;
        this.password = password;
        this.listener = listener;
    }

    @Override
    public void startJob() {
        cancelJob();
        HashMap<String,String> params = new HashMap<>();
        params.put("account",userName);
        params.put("password",password);

        loginTask = new HttpPostTask(params){

            @Override
            protected boolean parseResponse(String response) {
                return super.parseResponse(response);
            }

            @Override
            protected void onPostFail() {
                super.onPostFail();
                listener.onInteractFail("");
            }

            @Override
            protected void onPostSuccess() {
                super.onPostSuccess();
                listener.onInteractSuccess("");
            }
        };
        loginTask.executeOnExecutor(ThreadExecutor.getInstance().getExecutor(), UrlContainer.LOGIN_URL);
    }

    @Override
    public void cancelJob() {
        if(loginTask == null){
            return;
        }
        if(loginTask.getStatus()== AsyncTask.Status.RUNNING){
            loginTask.cancel(true);
        }
        loginTask = null;
    }

}
